#line 1 "C:/Evil Genius/MikroProC/P12F1572/DMX PWM/DMXPWM.c"
#line 15 "C:/Evil Genius/MikroProC/P12F1572/DMX PWM/DMXPWM.c"
unsigned int timeout, cnt, pbhold;
const Channels = 3;
char Text[4];
char DMX_Byte;
int DMX_Channel;
int FirstDeviceCh;
int LastDeviceCh;
char DMX_Array[Channels];
unsigned char DMXStartingAddress;
unsigned char DMXFlag;

void interrupt()
{
 if (PIR1.RCIF == 1)
 {
 if(RCSTA.FERR)
 {
 DMX_Byte = RCREG;
 DMX_Channel = 0;
 }
 else
 {
 if((DMX_Channel >= FirstDeviceCh) && (DMX_Channel < LastDeviceCh))
 {
 DMX_Array[DMX_Channel - FirstDeviceCh] = RCREG;
 }
 else
 {
 DMX_Byte = RCREG;
 }
 DMX_Channel++;
 }

 PIR1.RCIF = 0;
 }
}

void Init_PWM()
{
 CWG1CON0 = 0;

 SLRCONA.SLRA0 = 0;
 SLRCONA.SLRA1 = 0;
 SLRCONA.SLRA2 = 0;

 PWM1CON = 0b11000000;
 PWM1CLKCON = 0b00110001;
 PWM2CON = 0b11000000;
 PWM2CLKCON = 0b00110001;
 PWM3CON = 0b11000000;
 PWM3CLKCON = 0b00110001;

 PWM1PH = 0;
 PWM2PH = 0;
 PWM3PH = 0;
 PWM1DC = 0;
 PWM2DC = 0;
 PWM3DC = 0;
 PWM1PR = 30000;
 PWM2PR = 30000;
 PWM3PR = 30000;
}

void pwmUpdate()
{
 PWMLD.PWM1LDA_A = 1;
 PWMLD.PWM2LDA_A = 1;
 PWMLD.PWM3LDA_A = 1;
}

void PWMColor(unsigned char RedVal, unsigned char GreenVal, unsigned char BlueVal)
{
  PWM2DC  = RedVal * 255;
  PWM1DC  = GreenVal * 255;
  PWM3DC  = BlueVal * 255;
 pwmUpdate();
}


void InitDMXPort()
{
 SPBRGH = 0;
 SPBRGL = 3;
 TXSTA.BRGH = 1;
 TXSTA.SYNC = 0;
 PIE1 = 0;
 PIE1.RCIE = 1;
 RCSTA.RX9 = 1;
 DMX_Byte = RCREG;
 DMX_Byte = RCREG;
 DMX_Byte = RCREG;
 RCSTA.CREN = 1;
 RCSTA.SPEN = 1;
 RCSTA.ADDEN = 0;
 INTCON.PEIE = 1;
 INTCON.GIE = 1;
}

void main()
{
 ANSELA = 0b00000000;
 PORTA = 0b00000000;
 TRISA = 0b00110000;
 OSCCON = 0b01111010;
 DMX_Channel = 0;
 CM1CON0.C1ON = 0;
 INTCON.GIE = 1;
 INTCON.PEIE = 1;

 APFCON.RXDTSEL = 1;
 APFCON.P1SEL = 0;
 Init_PWM();
 InitDMXPort();

 DMXStartingAddress = 1;
 FirstDeviceCh = DMXStartingAddress;
 LastDeviceCh = FirstDeviceCh + Channels;



 while (1 == 1)
 {
 PWMColor(DMX_Array[0], DMX_Array[1], DMX_Array[2]);
 }
}
